// Jonathan Frech, 2024-03-16
// Cf. https://blog.jfrech.com/284
package main

import (
    "fmt"

    "sumtype"
)

type SummandC struct{}
func (SummandC) isSum() {}

func main() {
    f := func(v any) {
        _, ok := v.(sumtype.Sum)
        if sumtype.Is(v) != ok {
            panic("unreachable")
        }

        if sumtype.Is(v) {
            fmt.Printf("sumtype.Sum ∋ %T\n", v)
        } else {
            fmt.Printf("sumtype.Sum ∌ %T\n", v)
        }
    }

    f(sumtype.SummandA{})
    f(sumtype.SummandB{})
    f(SummandC{})
}
